/*
 * d_getkey.c
 *
 * $Source: /source/MASTER/garden/datlib/RCS/d_getkey.c,v $
 * $Date: 91/11/02 23:31:23 $
 * $Author: klee $
 * $Locker:  $
 *
 * This file is part of the dat library.
 *
 * $Log:	d_getkey.c,v $
 * Revision 1.4  91/11/02  23:31:23  klee
 * updated for const declarations
 * 
 * Revision 1.3  90/12/08  03:43:55  kaboom
 * Replaced under RCS, moved copyright message to copyright.h.
 * 
 * Revision 1.2  89/01/13  02:43:53  jwang
 * Add M.I.T. copyright message.
 * 
 * Revision 1.1  85/06/29  00:08:49  musicus
 * Initial revision
 * 
 *
 * #include	<dat.h>
 * 
 * char *
 * d_getkey(d,key)
 * 	DATFILE *d;
 * 	char *key;
 * 
 * 	returns the value of key from the header of dat file d, or else NULL.
 */

static char rcsid[] = "$Header: /source/MASTER/garden/datlib/RCS/d_getkey.c,v 1.4 91/11/02 23:31:23 klee Exp $" ;

#include "copyright.h"
#include <stdio.h>
#include "dat.h"


/* d_getkey(d,key)
 *
 *	returns the value of key from header of dat file, or else NULL
 */

const char *
d_getkey(d,gkey)
	const DATFILE *d;
	const char *gkey;
{
	struct d_token *tp;
	
	if((tp=d->db_h) != (struct d_token*) -1)
	{
		for(; tp!=NULL ; tp=tp->d_next)
		{
			if (strcmp(gkey, tp->d_key) == 0)
				return(tp->d_value);
		}
	}
	return(NULL);
}
