/*
Copyright 1989 by the Movies of the Future Group
of the MIT Media Laboratory
All rights reserved.

Permission to use, copy, and modify this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  This software or any
other copies thereof may not be provided or otherwise made available to
others.  No title to or ownership of the software is hereby transferred.
M.I.T. makes no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/
#include "dat.h"
#include "datio.h"

	/* Get definition of current submatrix (whole datfile if
		submatrix not in effect).  Returns number of dimensions,
		or -1 if unknown */

/* More logically d_getsubmatrix, but that name is too long on some machines */
int d_getmatrix(df,start,stop,step)
DATFILE *df;
struct d_addr *start,*stop,*step; /* may be NULL if not needed by caller */
{
	int d, xd, ndims;
	long dim[MAXD+2], origin, sizeproduct;
	register struct dinfo *ip;

	ndims = d_getdim(df, dim, dim+1, dim+2, MAXD);

	ip = _Dinfo[fileno(d_getfp(df))];
	origin = ip ? ip->offset >> ip->lbps : 0;
	sizeproduct = ip ? 1 << ip->lbps : 0;

	for (d=0, xd=ndims+1; xd>=0; d++, xd--) {
		long start1, stop1, step1;
		step1 = ip ? ip->basis[d] / sizeproduct : 1;
		start1 = origin % dim[xd];
		origin /= dim[xd];
		stop1 = ip ? start1 + step1*(ip->subdim[d]-1) + 1 : dim[xd];
		
		if (start) ((long *)start)[xd] = start1;
		if (stop) ((long *)stop)[xd] = stop1;
		if (step) ((long *)step)[xd] = step1;
		
		sizeproduct *= dim[xd];
	}

	return(ndims);
}
