/*
 * d_seek.c
 *
 * $Source: /source/MASTER/garden/datlib/RCS/d_seek.c,v $
 * $Date: 22/.1/.2 .2:.5:.1 $
 * $Author: holtzman $
 * $Locker:  $
 *
 * This file is part of the dat library.
 *
 * $Log:	d_seek.c,v $
 * Revision 1.4  22/.1/.2  .2:.5:.1  holtzman
 * Don't trust revision 1.3, reverted to 1.2
 * 
 * Revision 1.2  91/11/02  22:34:42  klee
 * found lying around...
 * 
 * Revision 1.1  90/12/08  03:55:05  kaboom
 * Initial revision
 * 
 */

#include "copyright.h"
#include "dat.h"
#include "datio.h"

static char rcsid[]="$Header: /source/MASTER/garden/datlib/RCS/d_seek.c,v 1.4 22/.1/.2 .2:.5:.1 holtzman Exp $";

/* #define STRICT 1			/* don't allow seeking to EOF position */

long 
  d_seek(df, distance, whence)
DATFILE *df;
struct d_addr *distance;
int whence;
{
  int fd, d, xd;
  register struct dinfo *ip;
  long elem;
  off_t seek, lseek();
  
  fd = fileno(d_getfp(df));
  if ((ip=_Dinfo[fd]) == NULLI) {
#ifdef APPEND_MODE
    if (d_submatrix(df, (struct d_addr *)-1, NULLA, NULLA) < 0)
      return(-1);
#else
    if (d_submatrix(df, NULLA, NULLA, NULLA) < 0)
      return(-1);
#endif
    ip = _Dinfo[fd];
  }
  
  /* compute position sought within submatrix */
  elem = (whence==2 || whence==1 && ip->eof);
  for (xd=0, d=ip->ndims; --d>=0; xd++) 
    {
      elem *= ip->subdim[d];
      if (distance) 
	elem += ((long *)distance)[xd];
      
      if (whence==1 && !ip->eof) 
	elem += ip->tell[d];
    }
  
  if (elem < 0) 
    goto error;	/* never allow seek to negative place */
  
  seek = 0;
  for (d=0; d<ip->ndims; d++) 
    {	/* adjust so that 0<=tell<subdim */
      long q = elem / ip->subdim[d];	/* Vax converts elem to unsigned;
					   okay since elem >= 0 */
      ip->tell[d] = elem - ip->subdim[d] * q; /* elem % ip->subdim[d] */
      elem = q;					/* elem / ip->subdim[d] */
      seek += ip->tell[d] * ip->basis[d];
    }
  
  ip->eof = (elem != 0);
#ifdef STRICT		/* seek target must be within submatrix */
  if (elem==0) 
    {
#else				/* okay to seek to exactly EOF */
      if (elem==0 || elem==1 && seek==0) 
	{
	  if (elem==1) 
	    seek = ip->subdim[ip->ndims-1] * ip->basis[ip->ndims-1];
#endif
	  return(lseek(fd, seek+ip->offset, 0) >> ip->lbps);
	}
	
#ifdef STRICT
    }
#endif

 error:
  return(_daterrh("d_seek: seek out of bounds on %s\n",
		  d_getname(df)));
}
