/*
 * datio.h
 *
 * $Source: /source/MASTER/garden/datlib/RCS/datio.h,v $
 * $Date: 91/11/02 22:35:05 $
 * $Author: klee $
 * $Locker:  $
 *
 * This file is part of the dat library.
 *
 * For compiling datio subroutines only: do not install!
 *
 * $Log:	datio.h,v $
 * Revision 1.2  91/11/02  22:35:05  klee
 * found lying around...
 * 
 */

#define MAXD N_DIMENSIONS
#define NULLA ((struct d_addr *) 0)
#define NULLI ((struct dinfo *) 0)

#include <sys/param.h>
#include <sys/types.h>

/*
dtype,lbps,ndims: information from DATFILE struct is cached for efficiency.

eof,tell: records state of datfile I/O pointer.  The lseek pointer in the data
file always corresponds to tell[], except the lseek pointer may be arbitrary
when eof!=0 or after an error condition.

hsub,subdim,offset,basis,nskip: records submatrix definition redundantly, for
efficiency.  These relations always hold:
	hsub == basis[0] >> lbps
	nskip[d] == basis[d+1] - basis[d]*subdim[d], for 0<=d<=ndims-2

tell,subdim,basis: only elememts [0:ndims-1] are valid;
nskip: only elements [0:ndims-2] are valid.
*/


/* local info on each open datfile */

extern struct dinfo {
  char dtype;			/* data type code */
  char lbps;			/* log2 bytes/sample */
  char ndims;			/* number of dimensions (includes datasets & */
				/* channels) */
  char eof;			/* != 0 if past end of array */
  unsigned hsub;		/* horizontal subsample rate */
  unsigned tell[MAXD+2];	/* address of current element in submatrix; */
				/* values are invalid if eof != 0 */
  unsigned subdim[MAXD+2];	/* dimensions of submatrix */
  off_t offset;			/* pointer to first subarray element */
  off_t basis[MAXD+2];		/* bytes to skip when address is incremented */
  off_t nskip[MAXD+2];		/* bytes to skip when address wraps around */
} *_Dinfo[];

/* #define APPEND_MODE */	/* support d_open for append -- untested */
