/*
Copyright 1989 by the Movies of the Future Group
of the MIT Media Laboratory
All rights reserved.

Permission to use, copy, and modify this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  This software or any
other copies thereof may not be provided or otherwise made available to
others.  No title to or ownership of the software is hereby transferred.
M.I.T. makes no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/
/* EMACS_MODES: c */
#include <stdio.h>
#include <signal.h>
#include <errno.h>

writerr(nwritten, file, buffer, count)
char buffer[];
{
	if (nwritten==-1) {		/* error */
		extern int errno;
		extern char *sys_errlist[];
		switch (errno) {
		case ENOSPC:
#ifdef EDQUOT
		case EDQUOT:
#endif
			fprintf(stderr,"write: %s (resume to retry)\n^Z\n",
				sys_errlist[errno]);
			killpg(0,SIGSTOP);		/* pause and retry */
			return(write(file, buffer, count));
		default:
			return(-1);
		}
	}
	else {					/* short: try writing the rest */
		register int i;
		i = write(file, buffer+nwritten, count-nwritten);
		return(i==-1 ? i : i+nwritten);
	}
}
